;*---------------------------------------------------------------------*/
;*    Copyright (c) 1993 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*---------------------------------------------------------------------*/
;*    serrano/prgm/project/bigloo/comptime1.2/Engine/path.scm ...      */
;*                                                                     */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Mon Dec 14 11:11:39 1992                          */
;*    Last change :  Mon May  3 09:41:22 1993  (serrano)               */
;*                                                                     */
;*    On affecte les path pour `lib' et `include'. C'est un tout petit */
;*    module car on veut lors de l'installation qu'il se compile vite. */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module engine_path
   (foreign (define string default-lib-dir () "LIBRARY_DIR")
	    (define string default-inc-dir () "INCLUDE_DIR"))
   (export  (get-lib-dir)
	    (get-inc-dir)))

;*---------------------------------------------------------------------*/
;*    get-lib-dir ...                                                  */
;*---------------------------------------------------------------------*/
(define (get-lib-dir)
   (let ((lib-env (getenv "BIGLOOLIB")))
      (if (string=? lib-env "")
	  (default-lib-dir)
	  lib-env)))

;*---------------------------------------------------------------------*/
;*    get-inc-dir ...                                                  */
;*---------------------------------------------------------------------*/
(define (get-inc-dir)
   (let ((inc-env (getenv "BIGLOOINCLUDE")))
      (if (string=? inc-env "")
	  (default-inc-dir)
	  inc-env)))
