;*---------------------------------------------------------------------*/
;*    Copyright (c) 1993 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*---------------------------------------------------------------------*/
;*    serrano/prgm/project/bigloo/comptime1.2/Expand/try.scm ...       */
;*                                                                     */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Sep  1 16:21:59 1992                          */
;*    Last change :  Wed May 12 13:41:53 1993  (serrano)               */
;*                                                                     */
;*    L'expansion de la forme try                                      */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module expand_try
   (import tools_error)
   (export (expand-try x e)))

;*---------------------------------------------------------------------*/
;*    expand-try ...                                                   */
;*---------------------------------------------------------------------*/
(define (expand-try x e)
   (match-case x
      ((?- ?body ?handler)
       (e `(let* ((lambda-stack (get-lambda-stack))
		  (res          (bind-exit (escape)
					   (add-error-handler! ,handler escape)
					   (let ((res ,body))
                                              (remove-error-handler!)
                                              res))))
	      ;; maintenant que le handler a ete invoque, il faut penser
	      ;; a nettoyer la pile des lambda
	      (set-lambda-stack! lambda-stack)
	      res)
	  e))
      (else
       (partial-error "try" "Illegal form" x))))
