;*---------------------------------------------------------------------*/
;*    Copyright (c) 1993 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;*---------------------------------------------------------------------*/
;*    serrano/prgm/project/bigloo/comptime1.2/Rgc/ustate.scm ...       */
;*                                                                     */
;*    Auteur      :  Manuel SERRANO                                    */
;*    Creation    :  Thu Jun 20 11:11:52 1991                          */
;*    Last change :  Thu Apr  8 11:57:09 1993  (serrano)               */
;*                                                                     */
;*    La generation des etats non-compactes                            */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*     Le module                                                       */
;*---------------------------------------------------------------------*/
(module rgc_automata_ustate
   (import  rgc_automata_transition
	    rgc_automata_automata
	    rgc_automata_optimize
	    engine_param)
   (export  (decl-ustate n v a n s)))
		  
;*---------------------------------------------------------------------*/
;*     decl-ustate ...                                                 */
;*---------------------------------------------------------------------*/
(define (decl-ustate state-name vector accept? nb-states state-num)
   ((if (looping? state-num accept?) code-ulooping code-ustate)
       state-name vector accept? nb-states state-num) )

;*---------------------------------------------------------------------*/
;*     code-ulooping ...                                               */
;*---------------------------------------------------------------------*/
(define (code-ulooping state-name vector accept? nb-states state-num)
   `(,state-name ()
		 (case (input-port-read-char input-port)
		    (,(vector-ref vector state-num)
		     (,state-name))
		    ((,@(let loop ( (i 0) )
			   (if (=fx i *first-char*)
			       '()
			       (cons i (loop (+fx 1 i))))))
		     (input-port-remember-back-ref input-port)
		     (if (input-port-fill-buffer input-port)
			 (,state-name)
			 ,@(accept? state-num)))
		    (else
		     (input-port-remember-back-ref input-port)
		     ,@(accept? state-num)))))

;*---------------------------------------------------------------------*/
;*     code-ustate ...                                                 */
;*---------------------------------------------------------------------*/
(define (code-ustate state-name vector accept? nb-states state-num)
   `(,state-name (mr)
	(case (input-port-read-char input-port)
	   ,@(let for ((i    (-fx nb-states 1))
		       (res '()))
		(if (<fx i 0)
		    (append res `((,(let loop ( (i 0) )
				       (if (=fx i *first-char*)
					   '()
					   (cons i (loop (+fx 1 i)))))
				   (if (input-port-fill-buffer input-port)
				       (,(state->symbol state-num) mr)
				       mr))
				  (else mr)))
		    (if (not (null? (vector-ref vector i)))
			(for (-fx i 1)
			     (cons
			      (list
			       (vector-ref vector i)
			       (code-> state-num (list 'dummy i) accept?))
			      res))
			(for (-fx i 1)
			     res)))))))



