;*---------------------------------------------------------------------*/
;*    serrano/prgm/project/bigloo/comptime1.2/Var/variable.sch ...     */
;*                                                                     */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Wed Mar 17 09:23:41 1993                          */
;*    Last change :  Thu Apr 29 16:41:05 1993  (serrano)               */
;*                                                                     */
;*    Les structures des variables utilisees pendant toutes les        */
;*    passes d'une compilation                                         */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*    Il existe plusieurs types de variables:                          */
;*       - Les variables `global'                                      */
;*       - Les variables `local'                                       */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*    global ...                                                       */
;*---------------------------------------------------------------------*/
(define-struct global
   name          ;; symbol      : le nom de la variable sans pretty-print
   module        ;; symbol      : le nom du module d'appartenance.
   c-name        ;; string      : le nom C de la variable.
   import        ;; { static, export, import, top-level, foreign }
   class         ;; { variable, function, foreign }
   library?      ;; { t, f }    : est-ce une fonction de la librairie ?
   value         ;; ???         : la valeur des constantes
   pragma        ;; ???         : des info pour les fonction de la lib.
   info)         ;; ???         : ce champs est utilise par toutes les passes

;*---------------------------------------------------------------------*/
;*    local ...                                                        */
;*---------------------------------------------------------------------*/
(define-struct local
   name          ;; symbol      : le nom de la variable sans pretty-print
   key           ;; integer     : une cle d'identification
   class         ;; { variable, function, return }
   value         ;; ???         : la valeur des constantes
   info          ;; ???         : ce champs est utilise par toutes les passes
   access)       ;; { read, write }
   
;*---------------------------------------------------------------------*/
;*    Les constantes peuvent avoir plusieurs valeurs:                  */
;*       - `function'                                                  */
;*       - `macro'                                                     */
;*       - `foreign'                                                   */
;*       - `return'                                                    */
;*---------------------------------------------------------------------*/

;*---------------------------------------------------------------------*/
;*    function ...                                                     */
;*---------------------------------------------------------------------*/
(define-struct function
   inline?       ;; { t, f }    : est-ce une inline ?
   property      ;; property*   : une liste de propriete
   arity         ;; integer     : l'arite de la fonction
   args          ;; local*      : les arguments d'une fonction
   body          ;; s-exp       : le corps.
   info          ;; ???         : des infos, pass dependant.
   escape?       ;; { t, f }    : cette fonction s'enfuie-t-elle ?
   the-closure)  ;; variable    : la variable fermeture

;*---------------------------------------------------------------------*/
;*    return ...                                                       */
;*---------------------------------------------------------------------*/
(define-struct return
   args          ;; local*      : les arguments d'un return
   body          ;; s-exp       : le corps.
   escape?       ;; { t, f }    : ce return s'enfuie-t-il ?
   the-continue) ;; variable    : la variable de continuation

;*---------------------------------------------------------------------*/
;*    foreign ...                                                      */
;*---------------------------------------------------------------------*/
(define-struct foreign
   class         ;; { function, variable, macro-function, macro-cnst }
   type)         ;; type        : le type de cette foreign
   
